var RAVEN = window.RAVEN || {};
RAVEN.Component = RAVEN.Component || {};
RAVEN.Component.LCarousel = (function($) {
	
	var LCarouseMap = [];

	this.apply = function(name, element, size, lastClick) {
		var jumpToFirstClick = lastClick !== undefined && lastClick === false;

		if( !LCarouseMap ) LCarouseMap = [];
		LCarouselName = name;
		LCarouselElement = element;
		LCarouselSize = size;
		
    	$(".dots-holder#" + name).remove();
    	var elements = element.children();
    	if(elements.length > size ) {
	    	$(elements).each(function(index,ele) {
	    		var id = Math.floor(index/size);
	    		$(ele).attr("data-lcarousel",name + "-" + id);
	    		$(ele).addClass("lcarousel-" + name);
	    		$(ele).hide();
	    	});
	    	
	    	var numDots = Math.floor( elements.length / size );
	    	if( elements.length % size > 0 ) numDots += 1;
	    	
	    	
	    	var dotsDiv = "<div class='dots-holder' id="+name+">";
	    	for(var i = 0 ; i < numDots ; i++ ) {
	    		dotsDiv += "<a href='#' class='dot' data-controls='" + name + "-" + i + "'></a>";
	    	}
	    	dotsDiv += "</div>";
	    	element.append(dotsDiv);
	    	
	    	$(".dots-holder#"+name+" .dot").on("click", function(e){
                e.preventDefault();
	    		var ele = $(e.target);
	    		var controls = ele.attr("data-controls");

	    		$(".dots-holder#"+name+" .dot").removeClass("selected");
	    		ele.addClass("selected");
	    		$(".lcarousel-" + name).hide();
	    		$(".lcarousel-" + name + "[data-lcarousel="+controls+"]").show();

	    		if(!jumpToFirstClick){
	    			LCarouseMap[name] = controls;
	    		}

	    		element.trigger('carouselSwipe');
	    	});

	    	var lastClicked = LCarouseMap[name];
	    	if(lastClicked && !jumpToFirstClick) {
	    			var index = lastClicked.split(name+"-")[1];
	    			while(index >= 0) {
	    				var ele = $(".dots-holder#"+name+" .dot[data-controls='" + name + "-" + index + "']");
	    	    		if(ele.length > 0) {
	    	    			ele.click();
	    	    			break;
	    	    		}
	    	    		index--;
	    			}
	    	} else {
	    		$(".dots-holder#"+name+" .dot[data-controls='" + name + "-0']").click();
	    	}
    	} else {
    		$(elements).each(function(index,ele) {
    			$(ele).show();
    		});
    	}
    }

	return this;
})(AJS.$);