(function($) {

    var testExecTestsColumns = null;
    var testTestExecsColumns = null;
    var testTestSetsColumns = null;
    var testTestPlansColumns = null;
    var testPreConditionColumns = null;
    var testSetTestsColumns = null;
    var testPlanTestsColumns = null;
    var testPlanTestExecsColumns = null;
    var projectTestsColumns = null;
    var projectTestSetsColumns = null;
    var projectTestExecsColumns = null;
    var projectTestPlansColumns = null;
    
    function formSubmitListener() {
        prepareTestExecTestsColumnIds();
        prepareTestPlanTestsColumnIds();
        prepareTestPlanTestExecsColumnIds();
        prepareTestTestExecsColumnIds();
        prepareTestPreConditionColumnIds();
        prepareTestTestSetsColumnIds();
        prepareTestTestPlansColumnIds();
        prepareTestSetTestsColumnIds();
        prepareProjectTestsColumnIds();
        prepareProjectTestSetsColumnIds();
        prepareProjectTestExecsColumnIds();
        prepareProjectTestPlansColumnIds();
        
        return true;
    }

    function prepareTestExecTestsColumnIds() {
        var ids = [];
        if (testExecTestsColumns) {
            // get ordered list of IDs
            ids = _.map(testExecTestsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#testexec-tests-column-ids').val(JSON.stringify(ids));
    }

    function prepareTestTestExecsColumnIds() {
        var ids = [];
        if (testTestExecsColumns) {
            // get ordered list of IDs
            ids = _.map(testTestExecsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#test-testexecs-column-ids').val(JSON.stringify(ids));
    }

    function prepareTestTestSetsColumnIds() {
        var ids = [];
        if (testTestSetsColumns) {
            // get ordered list of IDs
            ids = _.map(testTestSetsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#test-testsets-column-ids').val(JSON.stringify(ids));
    }

    function prepareTestTestPlansColumnIds(){
        var ids = [];
        if (testTestPlansColumns) {
            // get ordered list of IDs
            ids = _.map(testTestPlansColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#test-testplans-column-ids').val(JSON.stringify(ids));
    }

    function prepareTestSetTestsColumnIds() {
        var ids = [];
        if (testSetTestsColumns) {
            // get ordered list of IDs
            ids = _.map(testSetTestsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#testset-tests-column-ids').val(JSON.stringify(ids));
    }

    function prepareTestPreConditionColumnIds() {
        var ids = [];
        if (testPreConditionColumns) {
            // get ordered list of IDs
            ids = _.map(testPreConditionColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#preconditions-column-ids').val(JSON.stringify(ids));
    }

    function prepareProjectTestsColumnIds() {
        var ids = [];
        if (projectTestsColumns) {
            // get ordered list of IDs
            ids = _.map(projectTestsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#project-tests-column-ids').val(JSON.stringify(ids));
    }

    function prepareProjectTestSetsColumnIds() {
        var ids = [];
        if (projectTestSetsColumns) {
            // get ordered list of IDs
            ids = _.map(projectTestSetsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#project-testsets-column-ids').val(JSON.stringify(ids));
    }

    function prepareProjectTestExecsColumnIds() {
        var ids = [];
        if (projectTestExecsColumns) {
            // get ordered list of IDs
            ids = _.map(projectTestExecsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#project-testexecs-column-ids').val(JSON.stringify(ids));
    }
    
    function prepareProjectTestPlansColumnIds() {
        var ids = [];
        if (projectTestPlansColumns) {
            // get ordered list of IDs
            ids = _.map(projectTestPlansColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#project-testplans-column-ids').val(JSON.stringify(ids));
    }
    
    function prepareTestPlanTestsColumnIds() {
        var ids = [];
        if (testPlanTestsColumns) {
            // get ordered list of IDs
            ids = _.map(testPlanTestsColumns.lozengeGroup.items, function(descriptor) { 
                return descriptor.value;
            });
        }

        $('#testplan-tests-column-ids').val(JSON.stringify(ids));
    }

    function prepareTestPlanTestExecsColumnIds() {
        var ids = [];
        if (testPlanTestExecsColumns) {
            // get ordered list of IDs
            ids = _.map(testPlanTestExecsColumns.lozengeGroup.items, function(descriptor) {
                return descriptor.value;
            });
        }

        $('#testplan-testexecs-column-ids').val(JSON.stringify(ids));
    }

    function initMultiSelectPicker($selectField, errorMessage) {
        var PreventSubmitMultiSelect = AJS.MultiSelect.extend({
            submitForm: function () {
                // do nothing
            }
        });

        return new PreventSubmitMultiSelect({
            element: $selectField,
            itemAttrDisplayed: "label",
            showDropdownButton: true,
            removeOnUnSelect: false,
            submitInputVal: false,
            errorMessage: errorMessage,
            maxInlineResultsDisplayed: 30
        });
    }

    $(document).ready( function() {
        AJS.messages.setup();

        var testExecColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.testexec-tests.error");
        testExecTestsColumns = initMultiSelectPicker($('#testexec-tests-columns'), testExecColumnsErrorMessage);

        var testColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.test-testexecs.error");
        testTestExecsColumns = initMultiSelectPicker($('#test-testexecs-columns'), testColumnsErrorMessage);

        var testTestSetColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.test-testsets.error");
        testTestSetsColumns = initMultiSelectPicker($('#test-testsets-columns'), testTestSetColumnsErrorMessage);

        var testTestPlanColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.test-testplans.error");
        testTestPlansColumns = initMultiSelectPicker($('#test-testplans-columns'), testTestPlanColumnsErrorMessage);

        var preConditionColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.test-testexecs.error");
        testPreConditionColumns = initMultiSelectPicker($('#test-preconditions-columns'), preConditionColumnsErrorMessage);

        var testSetColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.testset-tests.error");
        testSetTestsColumns = initMultiSelectPicker($('#testset-tests-columns'), testSetColumnsErrorMessage);

        var testPlanTestColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.testplan-tests.error");
        testPlanTestsColumns = initMultiSelectPicker($('#testplan-tests-columns'), testPlanTestColumnsErrorMessage);

        var testPlanTestExecColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.testplan-testexecs.error");
        testPlanTestExecsColumns = initMultiSelectPicker($('#testplan-testexecs-columns'), testPlanTestExecColumnsErrorMessage);

        var projectTestColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.project-tests.error");
        projectTestsColumns = initMultiSelectPicker($('#project-tests-columns'), projectTestColumnsErrorMessage);

        var projectTestSetColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.project-testsets.error");
        projectTestSetsColumns = initMultiSelectPicker($('#project-testsets-columns'), projectTestSetColumnsErrorMessage);
 
        var projectTestExecColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.project-testexecs.error");
        projectTestExecsColumns = initMultiSelectPicker($('#project-testexecs-columns'), projectTestExecColumnsErrorMessage);
        
        var projectTestPlanColumnsErrorMessage = AJS.I18n.getText("raven-admin-config.general.column-layout.project-testplans.error");
        projectTestPlansColumns = initMultiSelectPicker($('#project-testplans-columns'), projectTestPlanColumnsErrorMessage);
        
        var form = document.getElementById('general-form');
        if (form) {
            if (form.attachEvent) {
                form.attachEvent("onsubmit", formSubmitListener);
            } else {
                form.addEventListener("submit", formSubmitListener);
            }
        }

        $('.aui-message.success').delay(5000).fadeOut('slow');
    });
})(AJS.$);
