(function($) {
    function initExpandableContent() {

        $(document).off('.tooltip.raven');

        // remove loose tipsies
        $('.tipsy:has(.list-expander-custom-field-tooltip-close)').remove();

        $(document).on('click.tooltip.raven', '.list-expander-custom-field-column-value a.content-expand', function(e) {
            e.preventDefault();

            var el = $(e.target).tooltip({
                trigger: 'manual',
                html: true,
                title: function() {
                    var $allTestSets = $(e.target).closest('.list-expander-custom-field-column-value').find('.list-expander-custom-field-more');
                    if ($allTestSets.length > 0) {
                        return $allTestSets.clone().css('display', 'block')[0].innerHTML;
                    } else {
                        return null;
                    }
                }
            });

            if (!el.hasClass('expanded')) {
                // collapse all other expanded test sets custom fields in page
                var expandedCfs = $('.list-expander-custom-field-column-value .content-expand.expanded');
                expandedCfs.removeClass('expanded');
                expandedCfs.text('(' + AJS.I18n.getText('common.label.show-more') + '...)');
                expandedCfs.tooltip('hide');

                el.tooltip('show');
                el.addClass('expanded');
                el.text('(' + AJS.I18n.getText('common.label.show-less') + '...)');
            } else {
                el.removeClass('expanded');
                el.tooltip('hide');
                el.text('(' + AJS.I18n.getText('common.label.show-more') + '...)');
            }
        });

        $(document).on('click.tooltip.raven', 'a.list-expander-custom-field-tooltip-close', function(e) {
            // collapse all other expanded test sets custom fields in page
            var expandedCfs = $('.list-expander-custom-field-column-value .content-expand.expanded');
            expandedCfs.removeClass('expanded');
            expandedCfs.text('(' + AJS.I18n.getText('common.label.show-more') + '...)');
            expandedCfs.tooltip('hide');

            // remove loose tipsies
            $('.tipsy:has(.list-expander-custom-field-tooltip-close)').remove();

            return false;
        });
    }

    // register for NEW_CONTENT_ADDED
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
        // FIXME: Both load page and refresh are called when loading a page and the table is loaded 2 times
        // test if our view is already loaded because pageLoaded event is called 2 times in the issue search page
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            initExpandableContent();
        }
    });

})(AJS.$);