/**
 * @constructor RAVEN.VersionPicker
 * @extends AJS.MultiSelect
 */
RAVEN.VersionPicker = AJS.MultiSelect.extend({

	init: function (options) {
		if (options && options.projectKey) {
			this.setProjectKey(options.projectKey);
		}

		this._super(options);

		if (!this.projectKey) {
			this.disable();
		}
	},

	setProjectKey: function(projectKey) {
		this.projectKey = projectKey;
	},
	
    _getDefaultOptions: function () {
		var self = this;
		
        return AJS.$.extend(true, this._super(), {
            ajaxOptions: {
                url: function() { 
					return contextPath + '/rest/api/2/project/' + self.projectKey + '/versions';
				},
                query: true,
                formatResponse: this._formatResponse,
            },
			itemAttrDisplayed: "label",
			submitInputVal: true,
            removeDuplicates: true,
            removeOnUnSelect: true,
            noQueryNoRequest: false,
            revertOnInvalid: true
        });
    },

    _formatResponse: function (data) {

        var optgroup = new AJS.GroupDescriptor({
            label: AJS.I18n.getText("Project Versions"),
            type: "optgroup"
        });

        if (data) {
            AJS.$.each(data, function () {
                optgroup.addItem(new AJS.ItemDescriptor({
                    value: this.id,
                    label: this.name,
                    title: this.description,
                    highlighted: true
                }));
            });
        }
        return [optgroup];
    }
});