RAVEN.namespace("RAVEN.gadget.fields");

function message(title, message, type) {
    if (!type) {
        type = 'error';
    }
    AJS.messages[type]($('#gadget-message'), {
        title: title,
        body: message
    });
}

RAVEN.gadget.fields.assigneePicker = function(gadget, userpref, label, description){
    var dropDownId = "dropdown-list-assignee" + userpref;
    var savedUser = gadget.getPref(userpref);

    if(savedUser === null || savedUser === undefined || savedUser === "") {
        savedUser = null;
    }

    return {
        userpref: userpref,
        label: label,
        id: "assignee-picker_" + userpref,
        type: "callbackBuilder",
        value: gadget.getPref(userpref),
        callback: function(parentDiv){
            parentDiv.append(
                AJS.$("<input/>").attr({id: "assignee_" + userpref + "_id", type: "hidden", name: userpref}).val(gadget.getPref(userpref))
            );

            parentDiv.append(
                AJS.$("<span/>").attr({id:"assignee_" + userpref + "_name"}).addClass("filterpicker-value-name field-value")
            );

            if(savedUser !== null) {
                AJS.$("#assignee_" + userpref + "_name").text(savedUser);
            } else {
                AJS.$("#assignee_" + userpref + "_name").text(gadget.getMsg("gadget.common.no-user-selected"));
            }

            parentDiv.append(
                AJS.$("<div/>").attr("id", "quickfind-container")
                .append(AJS.$("<label/>").addClass("overlabel").attr({"for":"quickfind-" + userpref, id: "quickfind-label-" + userpref}).text(gadget.getMsg("gadget.common.quick.find")))
                .append(AJS.$("<div/>").addClass("atlassian-autocomplete")
                    .append(AJS.$("<input/>").addClass("text").attr({id : "quickfind-" + userpref, autocomplete: "off"}))
                    .append(AJS.$("<div/>").addClass("suggestions aui-list dropdown-ready").attr({id : dropDownId}).css("top","30px").css("max-height","250px")
                        .append(AJS.$("<ul/>").addClass("aui-list-section aui-first aui-last").attr({id : "list-assignee-" + userpref}))
                    )
                )
                    .append(AJS.$("<span class='button clear-filter' style='width:55px; float:right;'>" + gadget.getMsg('gadget.common.clear') + "<span/>")
                ).append(
                    AJS.$("<span/>").addClass("inline-error")
                ).append(
                    AJS.$("<div/>").addClass("description").text(description).css("margin-top","35px")
                )
            );

            AJS.$("#" + dropDownId).hide();

            parentDiv.find('.clear-filter').click(function(e) {
                parentDiv.find("#assignee_" + userpref + "_id").val("");
                parentDiv.find("#assignee_" + userpref + "_name").text(gadget.getMsg("gadget.common.no-user-selected")).addClass("success");
                gadget.savePref(userpref, "");
            });

            parentDiv.find("#quickfind-" + userpref).on('focus keyup', function() {
                AJS.$.ajax({
                    type: "GET",
                    url: gadget.getBaseUrl() + "/rest/api/2/user/search?username=" + AJS.$("#quickfind-" + userpref).val() + "&maxResults=50&startAt=0",
                    contentType: "application/json",
                    global:false,
                    error: function (qXHR, textStatus, errorThrown) {
                        if (errorThrown && errorThrown.trim() != '') {
                            errorThrown = errorThrown + ': ' + qXHR.responseText;
                        } else {
                            errorThrown = qXHR.responseText;
                        }

                        message("error", errorThrown)
                    },
                    success: function (data, textStatus, jqXHR) {
                        AJS.$("#list-assignee-" + userpref).empty();
                        if(data.length > 0) {
                            AJS.$(data).each(function () {
                                var item = AJS.$("<li class='aui-list-item' />").attr("data-key", this.key).attr("data-name", this.displayName)
                                    .mouseover(function() {
                                        AJS.$(this).addClass("active");
                                    })
                                    .mouseout(function() {
                                        AJS.$(this).removeClass("active");
                                    })
                                    .click(function () {
                                        AJS.$("#assignee_" + userpref + "_id").val(AJS.$(this).data("key"));
                                        AJS.$("#assignee_" + userpref + "_name").addClass("success").text(AJS.$(this).data("key"));
                                        AJS.$("#quickfind-" + userpref).val("");
                                        AJS.$("#quickfind-label-" + userpref).show();
                                    });

                                var link = AJS.$("<a href='#' class='aui-list-item-link' />")
                                    .append(AJS.$("<span />").addClass("filter-name").attr("title", this.displayName + " - " + this.emailAddress).html(this.displayName + " - " + this.emailAddress))
                                    .click(function (e) {
                                        e.preventDefault();
                                    })
                                    .appendTo(item);

                                AJS.$("#list-assignee-" + userpref).append(item);
                            });
                            AJS.$("#" + dropDownId).show();
                        } else {
                            AJS.$("#" + dropDownId).hide();
                        }
                    }
                });
            });

            AJS.$(document).on('click',function (e) {
                if (!AJS.$("#quickfind-" + userpref).is(e.target)){
                    AJS.$("#" + dropDownId).hide();
                }
            });

            AJS.gadget.fields.applyOverLabel("quickfind-label-" + userpref);
        }
    };
};