(function($) {
    RAVEN.namespace("RAVEN.Gadget.fields");

    RAVEN.Gadget.fields.timeFrameSelect = function(gadget, userPref, label, description, disabled) {
    return {
        id: "timeFrame-callback-field",
        userpref: userPref,
        label: label,
        description: description,
        type: "callbackBuilder",
        callback: function(parentDiv) {
            var $el = $("<select></select>").attr({
                "id": userPref,
                "class": "select",
                "name": userPref
            });

            var selected;
            var currentWeek = gadget.getMsg("gadget.tests-evolution.common.field.time-frame.current-week");
            var lastWeek = gadget.getMsg("gadget.tests-evolution.common.field.time-frame.last-week");
            var currentMonth = gadget.getMsg("gadget.tests-evolution.common.field.time-frame.current-month");
            var lastMonth = gadget.getMsg("gadget.tests-evolution.common.field.time-frame.last-month");

            if (disabled === true) {
                $el.prop('disabled', true);
            }

            selected = gadget.getPref("timeFrame") === 'currentWeek' ? ' selected' : '';
            $el.append('<option value="currentWeek"' + selected + '>' + currentWeek + '</option>');

            selected = gadget.getPref("timeFrame") === 'lastWeek' ? ' selected' : '';
            $el.append('<option value="lastWeek"' + selected + '>' + lastWeek + '</option>');

            selected = gadget.getPref("timeFrame") === 'currentMonth' ? ' selected' : '';
            $el.append('<option value="currentMonth"' + selected + '>' + currentMonth + '</option>');

            selected = gadget.getPref("timeFrame") === 'lastMonth' ? ' selected' : '';
            $el.append('<option value="lastMonth"' + selected + '>' + lastMonth + '</option>');

            parentDiv.append($el);
        }
    };
}
})(AJS.$);