(function($) {

	var preConditionView = null;

	function onNewContentAdded(e, context, reason) {
		if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#raven-test-preconditions');
            if ($section.length > 0) {
                if (!$section.attr('data-initialized') && RAVEN.Utils.isCurrentIssueValid($('#raven-test-precondition-issue-key').val())) {
                    initialize();
                }
            } else if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad) {
                destroy();
            }
        }
	}

	function initialize() {
		destroy();

		preConditionView = new RAVEN.Test.PreConditionsView();

		$('#raven-test-preconditions').attr("data-initialized", "true");
	}

    function destroy() {
        if (preConditionView) {
            preConditionView.destroy();
            preConditionView = null;
        }
    }

	// register for NEW_CONTENT_ADDED
	JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
	JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

})(AJS.$);
