(function($) {

    var testPlanView = null;

    function onNewContentAdded(e, context, reason) {
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#raven-test-testplans');
            if ($section.length > 0) {
                if (!$section.attr('data-initialized') && RAVEN.Utils.isCurrentIssueValid($('#raven-test-testplans-issue-key').val())) {
                    initialize();
                }
            } else if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad) {
                destroy();
            }
        }
	}

    function initialize() {
        destroy();

        testPlanView = new RAVEN.Test.TestPlansView();

        $('#raven-test-testplans').attr("data-initialized", "true");
    }

    function destroy() {
        if (testPlanView) {
            testPlanView.destroy();
            testPlanView = null;
        }
    }

   	// register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

    $(document).ready(function() {
        $(document).on(RAVEN.Test.TestPlansView.REFRESH_VIEW, '#raven-test-testplans', function(e) {
            initialize();
        });
    });

})(AJS.$);
