(function($) {

    var testExecView = null;

    function onNewContentAdded(e, context, reason) {
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad ||  reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#raven-plan-testexecs');
            if ($section.length > 0) {
                if (!$section.attr('data-initialized') && RAVEN.Utils.isCurrentIssueValid($('#raven-testplan-testexecs-issue-key').val())) {
                    initialize();
                }
            } else if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad) {
                destroy();
            }
        }
    }

    function initialize() {
        destroy();

        testExecView = new RAVEN.TestPlan.TestExec.TestExecsView();

        $('#raven-plan-testexecs').attr("data-initialized", "true");
    }

    function destroy() {
        if (testExecView) {
            testExecView.destroy();
            testExecView = null;
        }
    }

    // register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

    $(document).ready(function() {
        $(document).on(RAVEN.TestPlan.TestExec.TestExecsView.REFRESH_VIEW, '#raven-plan-testexecs', function(e) {
            initialize();
        });
    });

})(AJS.$);
