(function($) {

    var testView = null;

    function onNewContentAdded(e, context, reason) {
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad || reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#raven-testset-tests');
            if ($section.length > 0) {
                if (!$section.attr('data-initialized') && RAVEN.Utils.isCurrentIssueValid($('#raven-testset-tests-issue-key').val())) {
                    initialize();
                }
            } else if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad) {
                destroy();
            }
        }
    }


    function initialize() {
        destroy();

        testView = new RAVEN.TestSet.TestsView();

        $('#raven-testset-tests').attr("data-initialized", "true");
    }

    function destroy() {
        if (testView) {
            testView.destroy();
            testView = null;
        }
    }

    // register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

    $(document).ready(function() {
        $(document).on(RAVEN.TestSet.TestsView.REFRESH_VIEW, '#raven-testset-tests', function(e) {
            initialize();
        });
    });

})(AJS.$);
