(function($) {

    var testExecView = null;

    function onNewContentAdded(e, context, reason) {
        if (reason == JIRA.CONTENT_ADDED_REASON.pageLoad ||  reason == JIRA.CONTENT_ADDED_REASON.panelRefreshed) {
            var $section = $('#testexecs-section');
            if ($section.length > 0 && !$section.attr('data-initialized')) {
                initialize();
            }
        }
    }

    function initialize() {
        if (testExecView) {
            testExecView.destroy();
            testExecView = null;
        }

        testExecView = new RAVEN.Project.TestExec.TestExecsView();

        $('#testexecs-section').attr("data-initialized", "true");
    }

    // register for NEW_CONTENT_ADDED
    JIRA.unbind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);
    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, onNewContentAdded);

    $(document).ready(function() {
        $(document).on(RAVEN.Project.TestExec.TestExecsView.REFRESH_VIEW, '#testexecs-section', function(e) {
            initialize();
        });
    });

})(AJS.$);